/*
 *	main.c
 *
 *	* Sun Jan 20 18:22:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

static void initialize();
static void finalize();

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

char state[(N_STATES + 7) / 8];	/* Xe[g */
TASK* root_task;		/* [g^XN */
TASK* game_task;		/* Q[^XN */
int timer;			/* ^C} */
int pad;			/* pbh */
PIECE_BMP bmp[2];		/* rbg}bv(0:}XN/1:Ȃ) */
int hi_score = 10000;		/* nCXRA */
FIELD field;			/* tB[h */

/****************************************************************************
 *	[Jϐ
 ****************************************************************************/

static int save0000;		/* NULL|C^݌op */
static char heap[0x2000];	/* malloc()pq[v̈(8KB) */

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	/* NULL|C^݌oB */
	if(*(int*)NULL != save0000) die("Write address 0");

	/* ^XNB */
	task_work(root_task);
	task_draw(root_task);

#ifdef DEBUG
	/* ^XN\܂B */
	pceFontSetType(0x82);
	pceFontSetTxColor(3);
	pceFontSetBkColor(0);
	pceFontSetPos(0, 0);
	pceFontPrintf("%2d", task_count(root_task));
#endif /*DEBUG*/

	/* ʓ]B */
	pceLCDTrans();

	/* VXeB */
	yield();

	/*--- t[̐؂ڂɂȂ܂ ---*/

	/* ^C}i߂B */
	timer++;

	/* pbh擾B */
	pad = pcePadGet();
}

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	initialize();

	for(;;) {
		demo();
		game();
	}

	return 0;
}

/****************************************************************************
 *	initialize
 ****************************************************************************/

static void
initialize()
{
	PBMP_FILEHEADER* hdr;

	pceLCDDispStop();

	/* NULL|C^݌ô߂ɁA[Ԓn̓eۑ܂B
	 * BIOS ver1.12ł́A̕ɂNULL|C^R[op̃R[h
	 *	xjp	biCall0_ent
	 * Ă܂B(ext;ext;jṕAext;ext̕)
	 */
	save0000 = *(int*)NULL;

	/* q[v̈܂B */
	ansi_InitMalloc((int)heap, (int)heap + sizeof heap);

	/* zVRAMAhXݒ肵܂B */
	pceLCDSetBuffer(vbuff);

	/* t[[gݒ肵܂B */
	pceAppSetProcPeriod(1000 / FPS);

	/* I[gs[g͎g܂B */
	pcePadSetTrigMode(PP_MODE_SINGLE);

	/* pceLCDDrawObjectCXg[܂B */
	hook_LCDDrawObject();

	/* rbg}bv܂B */
	hdr = (PBMP_FILEHEADER*)BITMAP;
	bmp[0].header = *hdr;
	bmp[0].buf = (unsigned char*)(hdr + 1);
	bmp[0].mask = bmp[0].buf + hdr->w * hdr->h / 4;
	bmp[1] = bmp[0];
	bmp[1].header.mask = 0; /* }XNȂ */

	/* [g^XN쐬܂B */
	root_task = task_new(NULL, 0);

	/* IɌĂ΂֐o^܂B */
	atexit(finalize);

	pceLCDDispStart();
}

/****************************************************************************
 *	finalize
 ****************************************************************************/

static void
finalize()
{
	/* pceLCDDrawObjectACXg[܂B */
	unhook_LCDDrawObject();

}
